/// <reference types="node" resolution-mode="require"/>
import { Transferable as DefaultTransferable, ExternalCopy, Reference } from '@forge/isolated-vm';
export declare enum ValidApiMethods {
    'api.fetch' = 0,
    'setTimeout' = 1,
    'clearTimeout' = 2,
    'setInterval' = 3,
    'clearInterval' = 4,
    'crypto.randomFillSync' = 5,
    'api.asUser.requestAtlassian' = 6,
    'api.asUser.requestConfluence' = 7,
    'api.asUser.requestJira' = 8,
    'api.asUser.requestBitbucket' = 9,
    'api.asUser.withProvider.fetch' = 10,
    'api.asUser.withProvider.requestCredentials' = 11,
    'api.asUser.withProvider.hasCredentials' = 12,
    'api.asUser.withProvider.listCredentials' = 13,
    'api.asUser.withProvider.getAccount' = 14,
    'api.asUser.withProvider.listAccounts' = 15,
    'api.asApp.requestAtlassian' = 16,
    'api.asApp.requestConfluence' = 17,
    'api.asApp.requestJira' = 18,
    'api.asApp.requestBitbucket' = 19,
    'api.requestRmsStore' = 20,
    'api.requestAiGateway' = 21,
    'api.requestJira' = 22,
    'api.requestConfluence' = 23,
    'api.requestBitbucket' = 24,
    'api.getAuthTokenReferences' = 25,
    'api.getAppAri' = 26,
    'api.webTrigger.getUrl' = 27,
    'logConsole' = 28,
    'getUserVars' = 29,
    'api.internalMetrics.invokeCounter' = 30,
    'api.internalMetrics.invokeGauge' = 31,
    'api.internalMetrics.invokeTimer' = 32,
    'api.webTrigger.deleteUrl' = 33,
    'api.webTrigger.getUrlIds' = 34
}
export declare type ValidApiMethodsType = keyof typeof ValidApiMethods;
export interface WrapOpts {
    release?: any;
    transfer?: any;
}
export declare type toExternalCopy = (arg: Transferable) => ExternalCopy<Transferable>;
export declare type toReference = (arg: Function, opts?: WrapOpts) => Reference<Function>;
export interface Serializer {
    serialize: (copy: toExternalCopy, wrap: toReference) => Transferable;
}
export declare type Transferable = DefaultTransferable | Record<string, any>;
export declare type BridgeArg = Transferable | Serializer | Function;
export interface Bridge {
    call(fn: ValidApiMethodsType, ...args: BridgeArg[]): any;
    callSync(fn: ValidApiMethodsType, ...args: BridgeArg[]): any;
    callIgnored(fn: ValidApiMethodsType, ...args: BridgeArg[]): any;
}
export interface ProcessStaticConfig {
    versions: NodeJS.ProcessVersions;
    version: string;
    platform: 'forge';
    env: Record<string, any>;
}
export interface RuntimeStaticConfig {
    process: ProcessStaticConfig;
}
export interface GlobalDefinitionInterface {
    define(bridge: Bridge, global: any, options?: Record<string, any>): void;
}
export interface DeferedMethodInvocation {
    method: string;
    args: unknown[];
}
//# sourceMappingURL=runtime-core-types.d.ts.map